#!/usr/bin/env python3

import asyncio

async def fibo(name, max):
    if max < 0:
        raise "Negative number"

    a, b = 0, 1
    for i in range(2, max+1):
        print(f"Task {name}: Compute fibonacci({i})...")
        await asyncio.sleep(1)
        a, b = b, a+b

    print(f"Task {name}: fibonacci({max}) = {b}")

async def main():
    result = await asyncio.gather(
        fibo("A", -1),
        fibo("B", 3),
        fibo("C", 4),
        fibo("D", 5),
        fibo("E", 6),
        return_exceptions=True
    )
    print(result)

asyncio.run(main())
