#!/usr/bin/env python3

import asyncio

async def fibo(future, value):
    await asyncio.sleep(5)

    a, b = 0, 1
    for i in range(2, value+1):
        a, b = b, a+b

    future.set_result(b)

async def main():
    ## define a future object
    future = asyncio.Future()
    ## wait for the completion of our coroutine that we've
    ## turned into a future object using the ensure_future() function
    await asyncio.ensure_future(fibo(future, 10))
    ## Print the result of our future
    print(future.result())

## Spin up a quick and simple event loop
## and run until completed
loop = asyncio.get_event_loop()
try:
    loop.run_until_complete(main())
finally:
    loop.close()
