#!/usr/bin/env python3

import asyncio
import random
import time

async def fibo(value):
    if value < 0:
        raise "Negative number"

    a, b = 0, 1
    for i in range(2, value+1):
        a, b = b, a+b

    print("Fibonacci: {} is {}".format(value, b))

async def random_delay(value):
    temp = random.randint(1,value+2)
    await asyncio.sleep(temp)
    await fibo(value)

async def main():
    tasks = []
    for i in range(15):
        tasks.append(asyncio.ensure_future(random_delay(i)))

    await asyncio.gather(*tasks)

start_time = time.time()
loop = asyncio.get_event_loop()
try:
    loop.run_until_complete(main())
finally:
    loop.close()
print("--- %.2f seconds ---" % (time.time() - start_time))
