#!/usr/bin/env python3

import random
import time
import asyncio

def regular_task(pid):
    t = random.randint(0, 4)
    time.sleep(t)
    print('Task %s done' % pid)

async def task_coroutine(pid):
    await asyncio.sleep(random.randint(0, 2))
    print('Task %s done' % pid)

def sequentially():
    for i in range(1, 10):
        regular_task(i)

async def concurrently():
    tasks = [task_coroutine(i) for i in range(1, 10)]
    await asyncio.gather(*tasks)

print('Sequentially:')
sequentially()

print('Non sequentially:')
asyncio.run(concurrently())
